;; The prime 41, can be written as the sum of six consecutive primes:
;; 41 = 2 + 3 + 5 + 7 + 11 + 13

;; This is the longest sum of consecutive primes that adds to a prime
;; below one-hundred.

;; The longest sum of consecutive primes below one-thousand that adds
;; to a prime, contains 21 terms, and is equal to 953.

;; Which prime, below one-million, can be written as the sum of the
;; most consecutive primes?

;; observations:

;; if the # of terms is even, then the terms must contain 2
;; (or the sum would be even)

;; if the # of terms is odd, then the terms can not contian 2
;; (or the sum would be even)

(defvar *primes-file* "/home/mortis/personal/projects/project-euler.net/data-files/prms.txt")

(defun load-primes ()
  (let ((primes (list)))
    (with-open-file (in *primes-file* :direction :input)
      (loop for line  = (read-line in nil nil)  then (read-line in nil nil)
	    while line
	    for prime = (read-from-string line) then (read-from-string line)
	    do
	    (when (< prime 1000000)
	      (push prime primes))))
    (reverse primes)))

(defvar *primes-table* '())

(progn
  (setf *primes-table* (load-primes))
  (length *primes-table*))

(defun primes-below (num)
  (let ((res (list)))
    (loop for ii in *primes-table*
	  do
	  (when (>= ii num)
	    (return t))
	  (push ii res))
    (reverse res)))

;; (length (primes-below 1000000))
;; (length (primes-below 41))

(defun prime? (num)
  (member num *primes-table*))

(defvar *prime-sums* nil)

(setf *prime-sums* (make-hash-table :test #'equal))

;; doens't work...
;; (asdf:*central-registry*)
;;(pushnew "/usr/share/common-lisp/systems" asdf:*central-registry* :test #'equal)
;;(require 'onlisp-system)

;;(load "/usr/share/common-lisp/source/onlisp/onlisp.lisp")
;;(import '(acond) :onlisp)

(defmacro acond (&rest clauses)
  (if (null clauses)
      nil
      (let ((cl1 (car clauses))
            (sym (gensym)))
        `(let ((,sym ,(car cl1)))
           (if ,sym
               (let ((it ,sym)) ,@(cdr cl1))
               (acond ,@(cdr clauses)))))))

(defun find-sums-of-prime (prime)
  (format t "find-sums-of-prime: ~a~&" prime)
  (acond ((gethash prime *prime-sums*)
	  (format t "in prime-sums: ~a => ~a~&" prime it)
	  it)
	 (t
	  (declare (ignore it))
	  (format t "searching for sums...~&")
	  (loop 
	   for num in (primes-below prime)
	   for diff = (- prime num) then (- prime num)
	   do
	   (format t "need to find prime:~a num:~a diff:~a~&"
		   prime num diff)))))

;;(find-sums-of-prime 41)












;; (defun find-prime-sum (primes upper-bound)
;;   (let ((max 0)
;; 	(components (list))
;; 	(prm 0))
;;     (loop for prime in primes
;; 	  for cmps = (list prime) then (cons prime cmps)
;; 	  for sum = prime then (+ sum prime)
;; 	  do
;; 	  (when (> sum upper-bound)
;; 	    (return t))
;; 	  (when (and (> sum max)
;; 		     (prime? sum))
;; 	    (setf max sum)
;; 	    (setf components cmps)
;; 	    (setf prm prime)))
;;     components))

;; (apply #'+ (find-prime-sum (primes-below 100) 100)) ;; 41

;; (defun find-longest-seq ()
;;   (let ((primes (primes-below 1000000))
;; 	(components (list)))
;;     (loop 
;;      for rem-primes = primes then (rest rem-primes)
;;      do
;;      (when (not rem-primes)
;;        (return t))
;;      (when (= 0 (mod (length primes) 100))
;;        (format t "."))
;;      (let ((cmps (find-prime-sum rem-primes 1000000)))
;;       (when (> (length cmps) (length components))
;; 	(format t "found new max: ~a => ~a~&"
;; 		(length components)
;; 		(apply #'+ components))
;; 	(setf components cmps))))
;;     (format t "max: ~a => ~a~&" 
;; 	    (length components)
;; 	    (apply #'+ components))))

;; ;; (time (find-longest-seq))

